<?php

/* ************************************************************************* *\
	MODERATION
\* ************************************************************************* */


function murm_moderation_page() {
	if( !murm_is_active() ) {
		return;
	}
	
	/*murm_nag( 'Tento plugin je ve vývoji. Pokud se vyskytnou jakékoliv problémy nebo nejasnosti, kontaktujte <a href="mailto:zaantar@zaantar.eu">vývojáře</a>. Díky za pochopení.' );*/

	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }

	switch( $action ) {
	case 'approve':
		murm_moderation_page_approve();
		murm_moderation_page_default();
		break;
	case 'deny':
		murm_moderation_page_deny();
		murm_moderation_page_default();
		break;
	case 'confirm-delete':
		murm_moderation_page_confirm_delete();
		break;
	case 'delete':
		murm_moderation_page_delete();
		murm_moderation_page_default();
		break;
	default:
		murm_moderation_page_default();
	}
}


function murm_moderation_page_default() {
	global $wpdb;
	
	$query = '
		SELECT id, username, email, displayname, url, message
		FROM '.$wpdb->prefix.'murm_requests';
		
	$requests = $wpdb->get_results( $wpdb->prepare( $query ) );
	
	?>
	<div class="wrap">
		<h2><?php _e( 'Registration requests on this blog' , MURM_TEXTDOMAIN ); ?><!--Žádosti o registrace na tomto blogu --></h2>
		<table class="widefat" cellspacing="0">
		    <thead>
		        <tr>
		            <th scope="col" class="manage-column"><?php _e( 'id' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'User name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'E-mail' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Displayed name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Web page' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Message for blog owner' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Action' , MURM_TEXTDOMAIN ); ?></th>
				</tr>
			</thead>
			<tfoot>
		        <tr>
		            <th scope="col" class="manage-column"><?php _e( 'id' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'User name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'E-mail' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Displayed name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Web page' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Message for blog owner' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Action' , MURM_TEXTDOMAIN ); ?></th>
				</tr>
			</tfoot>
			<?php
				foreach( $requests as $request ) {
					?>
					<tr>
						<td><?php echo $request->id; ?></td>
						<td><?php echo $request->username; ?></td>
						<td><?php echo $request->email; ?></td>
						<td><?php echo $request->displayname; ?></td>
						
						<td><?php echo $request->url; ?></td>
						<td><?php echo $request->message; ?></td>
						<td>
							<a href="users.php?page=murm-moderation&action=approve&id=<?php echo $request->id; ?>"><?php _e( 'Approve' , MURM_TEXTDOMAIN ); ?></a>
							&nbsp;&nbsp;
							<a href="users.php?page=murm-moderation&action=deny&id=<?php echo $request->id; ?>"><?php _e( 'Deny' , MURM_TEXTDOMAIN ); ?></a>
							&nbsp;&nbsp;
							<a href="users.php?page=murm-moderation&action=confirm-delete&id=<?php echo $request->id; ?>"><?php _e( 'Delete' , MURM_TEXTDOMAIN ); ?></a>
						</td>
					</tr>
				
					<?php
				}
			?>
		</table>
	</div>
	<?php
}


function murm_moderation_page_approve() {
	global $wpdb, $blog_id;
	
	$rid = $_REQUEST['id'];
	
	murm_log( 'admin approving registration request '.$rid );
	
	$request = murm_get_admin_request( $rid );
	
	if( $request == NULL ) {
		murm_nagerr( sprintf( __( 'Request no.%d was not found in the database, so it cannot be approved. If you think this is an error, please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error - rr '.$rid.' doesnt exist', 4 );
		return;
	}
	
	$insert_data = array(
		'blog_id' => $blog_id,
		'approved_by' => get_current_user_id(),
		'username' => $request->username,
		'email' => $request->email,
		'displayname' => $request->displayname,
		'url' => $request->url,
		'message' => $request->message
	);
	
	$iok = $wpdb->insert( $wpdb->base_prefix.'murm_requests', $insert_data );
	
	if( !$iok ) {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while inserting to superadmin moderation table: '.print_r( $insert_data, TRUE ), 4 );
		return;
	}
	
	extract( murm_get_site_settings() );

	murm_log( 'sending mail to superadmin' );
	$subject = murm_parse_mail( $to_superadmin_new_request['subject'], $blog_id, $request );
	$message = murm_parse_mail( $to_superadmin_new_request['message'], $blog_id, $request );
	wp_mail( get_site_option( 'admin_email' ), $subject, $message );
	
	$dok = murm_delete_admin_request( $rid );
	
	if( $dok ) {
		murm_nag( sprintf( __( 'Request no.%d has been approved and forwarded to superadmin for moderation. Now please be patient, we you will be informed about further development via e-mail.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'rr approved by admin', 2 );
	} else {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be fully processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while removing rr from db', 4 );
	}
}


function murm_moderation_page_deny() {
	$rid = $_REQUEST['id'];
	
	murm_log( 'admin denying registration request '.$rid );
	
	$request = murm_get_admin_request( $rid );
	
	if( $request == NULL ) {
		murm_nagerr( sprintf( __( 'Request no.%d was not found in the database, so it cannot be denied. If you think this is an error, please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error - rr '.$rid.' doesnt exist', 4 );
		return;
	}
	
	extract( murm_get_site_settings() );
	
	murm_log( 'sending mail to requesting user' );
	$subject = murm_parse_mail( $to_user_deny_from_admin['subject'], $blog_id, $request );
	$message = murm_parse_mail( $to_user_deny_from_admin['message'], $blog_id, $request );	
	wp_mail( $request->email, $subject, $message );
	
	$dok = murm_delete_admin_request( $rid );
	
	if( $dok ) {
		murm_nag( sprintf( __( 'Request no.%d has been denied and an information e-mail has been sent to the request author.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'rr successfully denied', 2 );
	} else {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be fully processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while removing rr from db', 4 );
	}
}


function murm_moderation_page_confirm_delete() {
	$rid = $_REQUEST['id'];
	$request = murm_get_admin_request( $rid );
	?>
	<div class="wrap">
		<h2><?php _e( 'Registration requests on this blog' , MURM_TEXTDOMAIN ); ?></h2>
		<p><?php printf( __( 'You are about to delete reqistration request no.%d (user %s with e-mail %s). Do you really want to proceed?' , MURM_TEXTDOMAIN ), $rid, '<em>'.$request->username.'</em>', '<em>'.$request->email.'</em>' ); ?></p>
		<p><?php _e( 'When deleting a request, the requesting person is not informed about it (on the contrary to denying the request). You should use this function only to delete spam or otherwise processed requests.' , MURM_TEXTDOMAIN ); ?><!--
			Při odstranění žádosti (narozdíl od jejího zamítnutí) není žádající nijak informován, tato funkce tedy slouží pouze jako stornování již jinak vyřešených žádostí anebo k odstranění spamu. Jinak byste ji využívat neměli.--></p>
		<form method="post" action="users.php?page=murm-moderation">
			<input type="hidden" name="action" value="delete" />
			<input type="hidden" name="id" value="<?php echo $rid; ?>" />
			<p class="submit">
	            <input type="submit" value="<?php _e( 'Delete request' , MURM_TEXTDOMAIN ); ?>" />    
	        </p> 
		</form>
		<p>
			&laquo; <a href="users.php?page=murm-moderation"><?php _e( 'Back to request overview' , MURM_TEXTDOMAIN ); ?></a> &laquo;
		</p>
	</div>
	<?php
}


function murm_moderation_page_delete() {
	$rid = $_REQUEST['id'];

	murm_log( 'admin deleting registration request '.$rid );

	$dok = murm_delete_admin_request( $rid );
	
	if( $dok ) {
		murm_nag( sprintf( __( 'Request no.%d has been deleted and an information e-mail has <strong>not</strong> been sent to the request author.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'rr '.$rid.' successfully deleted', 2 );
	} else {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be fully processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while deleting rr '.$rid.' from db', 4 );
	}

}


/* ************************************************************************* *\
	SUPERADMIN
\* ************************************************************************* */


function murm_superadmin_page() {	
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }

	switch( $action ) {
	case 'deny':
		murm_superadmin_page_deny();
		murm_superadmin_page_default();
		break;
	case 'approve':
		murm_superadmin_page_approve();
		murm_superadmin_page_default();
		break;
	case 'confirm-delete':
		murm_superadmin_page_confirm_delete();
		break;
	case 'delete':
		murm_superadmin_page_delete();
		murm_superadmin_page_default();
		break;
	default:
		murm_superadmin_page_default();
	}
}



function murm_superadmin_page_default() {
	global $wpdb;
	
	$query = '
		SELECT requests.id AS id, requests.username AS username, requests.email AS email, 
			requests.displayname AS displayname, requests.url AS url, requests.message AS message, 
			requests.blog_id AS blog_id, users.user_login AS approved_by, blogs.domain AS domain
		FROM ( '.$wpdb->base_prefix.'murm_requests AS requests
			JOIN  '.$wpdb->users.' AS users
			ON requests.approved_by = users.ID )
			JOIN '.$wpdb->base_prefix.'blogs AS blogs
			ON requests.blog_id = blogs.blog_id
		ORDER BY
			domain ASC,
			username ASC';
		
	$requests = $wpdb->get_results( $wpdb->prepare( $query ) );
	
	?>
	<div class="wrap">
		<h2><?php _e( 'MURM Network Registration Request' , MURM_TEXTDOMAIN ); ?></h2>
		<table class="widefat" cellspacing="0">
		    <thead>
		        <tr>
		            <th scope="col" class="manage-column"><?php _e( 'id' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Blog' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'User name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'E-mail' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Displayed name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Web page' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Message for blog owner' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Approved by' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Action' , MURM_TEXTDOMAIN ); ?></th>
				</tr>
			</thead>
			<tfoot>
		        <tr>
		            <th scope="col" class="manage-column"><?php _e( 'id' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Blog' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'User name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'E-mail' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Displayed name' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Web page' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Message for blog owner' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Approved by' , MURM_TEXTDOMAIN ); ?></th>
		            <th scope="col" class="manage-column"><?php _e( 'Action' , MURM_TEXTDOMAIN ); ?></th>
				</tr>
			</tfoot>
			<?php
				foreach( $requests as $request ) {
					?>
					<tr>
						<td><?php echo $request->id; ?></td>
						<td><?php echo $request->domain; ?></td>
						<td><?php echo $request->username; ?></td>
						<td><?php echo $request->email; ?></td>
						<td><?php echo $request->displayname; ?></td>
						<td><?php echo $request->url; ?></td>
						<td><?php echo $request->message; ?></td>
						<td><?php echo $request->approved_by; ?></td>
						<td>
							<a href="users.php?page=murm-superadmin&action=approve&id=<?php echo $request->id; ?>"><?php _e( 'Approve' , MURM_TEXTDOMAIN ); ?></a>
							&nbsp;&nbsp;
							<a href="users.php?page=murm-superadmin&action=deny&id=<?php echo $request->id; ?>"><?php _e( 'Deny' , MURM_TEXTDOMAIN ); ?></a>
							&nbsp;&nbsp;
							<a href="users.php?page=murm-superadmin&action=confirm-delete&id=<?php echo $request->id; ?>"><?php _e( 'Delete' , MURM_TEXTDOMAIN ); ?></a>
						</td>
					</tr>
				
					<?php
				}
			?>
		</table>
	</div>
	<?php
}



function murm_superadmin_page_approve() {
	$rid = $_REQUEST['id'];

	murm_log( 'superadmin approving request '.$rid );

	$request = murm_get_superadmin_request( $rid );
	
	if( $request == NULL ) {
		murm_nagerr( sprintf( __( 'Request no.%d was not found in the database, so it cannot be approved. If you think this is an error, please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error - rr '.$rid.' doesnt exist', 4 );
		return;
	}
	
	// vytvořit uživatele
	if( !murm_is_valid_combination( $request->username, $request->email ) ) {
		murm_nagerr( sprintf( __( 'Cannot create the user account - combination of username and e-mail (%s, %s) is already taken.' , MURM_TEXTDOMAIN ), $request->username , $request->email ) );
		murm_log( 'error - invalid username and email combination', 4 );
		return;	
	}
	
	extract( murm_get_site_settings() );
	
	if( username_exists( $request->username ) ) {
		murm_log( 'user already exists - adding to blog' );
		$user = get_userdatabylogin( $request->username );
		
		switch_to_blog( $request->blog_id );
		if( user_can( $user->ID, 'read' ) ) {
			murm_nagerr( sprintf( __( 'User %s is already registered on this blog. Cannot continue.' , MURM_TEXTDOMAIN ), $request->username ) );
			murm_log( 'error - user '.$request->username.' already registered on blog '.$request->blog_id, 4 );
			return;
		} 
		restore_current_blog();
		
		add_user_to_blog( $request->blog_id, $user->ID, 'subscriber' );
		
		$user_subject = murm_parse_mail( $to_existing_user_on_approve['subject'], $request->blog_id, $request );
		$user_message = murm_parse_mail( $to_existing_user_on_approve['message'], $request->blog_id, $request );	
	} else {
		$password = wp_generate_password( 12, false );
		$uid = wp_create_user( $request->username, $password, $request->email );
		$userdata = array( 
			'ID' => $uid,
			'user_url' => $request->url,
			'display_name' => $request->displayname,
		);
		wp_update_user( $userdata );
		add_user_to_blog( $request->blog_id, $uid, 'subscriber' );
		murm_log( 'creating new user '.$request->username.', '.$request->email.': '.print_r( $userdata, TRUE ).'; password: '.$password );
		$user_subject = murm_parse_mail( $to_new_user_on_approve['subject'], $request->blog_id, $request, $password );
		$user_message = murm_parse_mail( $to_new_user_on_approve['message'], $request->blog_id, $request, $password );	
	}
	
	// mail uživateli
	murm_log( 'sending mail to user' );
	wp_mail( $request->email, $user_subject, $user_message );	
	
	// mail adminovi
	murm_log( 'sending mail to admin' );
	$admin_subject = murm_parse_mail( $to_admin_on_superadmin_approve['subject'], $request->blog_id, $request );
	$admin_message = murm_parse_mail( $to_admin_on_superadmin_approve['message'], $request->blog_id, $request );	
	$admin = get_userdata( $request->approved_by );
	wp_mail( $admin->user_email, $admin_subject, $admin_message );
	
	// odstranit žádost
	$dok = murm_delete_superadmin_request( $rid );
	
	if( $dok ) {
		murm_nag( sprintf( __( 'Request no.%d has been approved. Blog owner and requesting user have been informed via e-mail.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'rr successfully approved', 2 );
	} else {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be fully processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while deleting rr from db', 4 );
	}
}


function murm_superadmin_page_deny() {
	$rid = $_REQUEST['id'];
	
	murm_log( 'superadmin denying registration request '.$rid );
	
	$request = murm_get_superadmin_request( $rid );
	
	if( $request == NULL ) {
		murm_nagerr( sprintf( __( 'Request no.%d was not found in the database, so it cannot be denied. If you think this is an error, please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error - rr '.$rid.' doesnt exist', 4 );
		return;
	}
	
	extract( murm_get_site_settings() );
	
	// mail adminovi
	murm_log( 'sending mail to admin' );
	$admin_subject = murm_parse_mail( $to_admin_on_superadmin_deny['subject'], $request->blog_id, $request );
	$admin_message = murm_parse_mail( $to_admin_on_superadmin_deny['message'], $request->blog_id, $request );	
	$admin = get_userdata( $request->approved_by );
	wp_mail( $admin->user_email, $admin_subject, $admin_message );

	// mail žádajícímu
	murm_log( 'sending mail to user' );
	$user_subject = murm_parse_mail( $to_user_deny_from_superadmin['subject'], $request->blog_id, $request );
	$user_message = murm_parse_mail( $to_user_deny_from_superadmin['message'], $request->blog_id, $request );	
	wp_mail( $request->email, $user_subject, $user_message );
	
	$dok = murm_delete_superadmin_request( $rid );
	
	if( $dok ) {
		murm_nag( sprintf( __( 'Request no.%d has been denied and an information e-mail has been sent to the request author and blog owner.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'rr successfully denied', 2 );
	} else {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be fully processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while removing rr from db', 4 );
	}
}


function murm_superadmin_page_confirm_delete() {
	$rid = $_REQUEST['id'];
	$request = murm_get_superadmin_request( $rid );
	?>
	<div class="wrap">
		<h2><?php _e( 'MURM Network Registration Request' , MURM_TEXTDOMAIN ); ?></h2>
		<p><?php printf( __( 'You are about to delete reqistration request no.%d (user %s with e-mail %s). Do you really want to proceed?' , MURM_TEXTDOMAIN ), $rid, '<em>'.$request->username.'</em>', '<em>'.$request->email.'</em>' ); ?></p>
		<p><?php _e( 'When deleting a request, the requesting person is not informed about it (on the contrary to denying the request). You should use this function only to delete spam or otherwise processed requests.' , MURM_TEXTDOMAIN ); ?></p>
		<form method="post" action="users.php?page=murm-superadmin">
			<input type="hidden" name="action" value="delete" />
			<input type="hidden" name="id" value="<?php echo $rid; ?>" />
			<p class="submit">
	            <input type="submit" value="<?php _e( 'Delete request' , MURM_TEXTDOMAIN ); ?>" />    
	        </p> 
		</form>
		<p>
			&laquo; <a href="users.php?page=murm-superadmin"><?php _e( 'Back to reguest overview' , MURM_TEXTDOMAIN ); ?></a> &laquo;
		</p>
	</div>
	<?php
}


function murm_superadmin_page_delete() {
	$rid = $_REQUEST['id'];
	
	murm_log( 'superadmin deleting registration request '.$rid );
	
	$dok = murm_delete_superadmin_request( $rid );
	
	if( $dok ) {
		murm_nag( sprintf( __( 'Request no.%d has been deleted and no information e-mail has <strong>not</strong> been sent to the request author.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'rr successfully deleted', 2 );
	} else {
		murm_nagerr( sprintf( __( 'Database error, request no.%d could not be fully processed. Please contact the plugin developer.' , MURM_TEXTDOMAIN ), $rid ) );
		murm_log( 'error while removing rr from db', 4 );
	}

}


?>
