<?php

/*****************************************************************************\
	SITE OPTIONS
\*****************************************************************************/


add_action( 'network_admin_menu','murm_network_admin_menu_options' );


function murm_network_admin_menu_options() {
	add_submenu_page( 'settings.php', __( 'MURM', MURM_TEXTDOMAIN ), __( 'MURM', MURM_TEXTDOMAIN ),
		'manage_network_options', 'murm-site-settings', 'murm_site_settings_page' );
}


function murm_site_settings_page() {
	
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }
    
    switch( $action ) {
    case 'update-settings':
		murm_update_site_settings( $_POST['settings'] );
		//print_r( $_POST['settings'] );
		murm_site_settings_page_default();
    	break;
    default:
    	murm_site_settings_page_default();
    }
}

// TODO keyword description

function murm_site_settings_page_default() {

	$settings = murm_get_site_settings();
	extract( $settings );
	
	?>
	<div class="wrap">
		<h2><?php _e( 'Nastavení Multisite User Registration Manager', MURM_TEXTDOMAIN ); ?></h2>
        <form method="post">
            <input type="hidden" name="action" value="update-settings" />
            <h3><?php _e( 'E-mail templates' ); ?></h3>
            <table class="form-table">
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For request author on denial by blog owner', MURM_TEXTDOMAIN ); ?></label>
                		<p style="font-size: x-small;"><?php _e( 'Within e-mail templates you can use following keywords:', MURM_TEXTDOMAIN ); ?></p>
                		<ol style="font-size: x-small;">
		            		<li><code>%SITE_NAME%</code>: </li>
							<li><code>%SITE_URL%</code>: </li>
							<li><code>%SUPERADMIN_EMAIL%</code>: </li>
							<li><code>%BLOG_NAME%</code>: </li>
							<li><code>%BLOG_URL%</code>: </li>
							<li><code>%ADMIN_EMAIL%</code>: </li>
							<li><code>%LOGIN_URL%</code>: </li>
							<li><code>%USER_NAME%</code>: </li>
							<li><code>%USER_EMAIL%</code>: </li>
							<li><code>PASSWORD</code>: </li>
						</ol>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_user_deny_from_admin][subject]" value="<?php echo $to_user_deny_from_admin['subject']; ?>" size="60" /><br />
                		<textarea name="settings[to_user_deny_from_admin][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_user_deny_from_admin['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For blog owner on incoming request', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_admin_new_request][subject]" value="<?php echo $to_admin_new_request['subject']; ?>" size="60" /><br />
                		<textarea name="settings[to_admin_new_request][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_admin_new_request['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For superadmin on incoming request', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_superadmin_new_request][subject]" value="<?php echo $to_superadmin_new_request['subject']; ?>" size="60" /><br />
                		<textarea name="settings[to_superadmin_new_request][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_superadmin_new_request['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For request author on denial by superadmin', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_user_deny_from_superadmin][subject]" value="<?php echo $to_user_deny_from_superadmin['subject']; ?>" size="60"  /><br />
                		<textarea name="settings[to_user_deny_from_superadmin][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_user_deny_from_superadmin['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For blog owner on denial by superadmin', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_admin_on_superadmin_deny][subject]" value="<?php echo $to_admin_on_superadmin_deny['subject']; ?>" size="60"  /><br />
                		<textarea name="settings[to_admin_on_superadmin_deny][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_admin_on_superadmin_deny['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For blog owner on approval by superadmin', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_admin_on_superadmin_approve][subject]" value="<?php echo $to_admin_on_superadmin_approve['subject']; ?>" size="60"  /><br />
                		<textarea name="settings[to_admin_on_superadmin_approve][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_admin_on_superadmin_approve['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For request author on approval (when creating new user account)', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_new_user_on_approve][subject]" value="<?php echo $to_new_user_on_approve['subject']; ?>" size="60" /><br />
                		<textarea name="settings[to_new_user_on_approve][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_new_user_on_approve['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><?php _e( 'For request author on approval (when registering an existing user account)', MURM_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<label><?php _e( 'Subject:', MURM_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="settings[to_existing_user_on_approve][subject]" value="<?php echo $to_existing_user_on_approve['subject']; ?>" size="60" /><br />
                		<textarea name="settings[to_existing_user_on_approve][message]" cols="80" rows="15"><?php 
            				echo stripslashes( esc_textarea( $to_existing_user_on_approve['message'] ) ); 
            			?></textarea>
                	</td>
                </tr>
			</table>
			<p><small><em>czech default values are somewhere in the source code...</em></small></p>
			<p class="submit">
	            <input type="submit" class="button-primary" value="<?php _e( 'Save', MURM_TEXTDOMAIN ); ?>" />    
	        </p>
		</form>
	</div>
	<?php
}


define( 'MURM_SITE_SETTINGS', 'murm_site_settings' );


function murm_update_site_settings( $settings ) {
	update_site_option( MURM_SITE_SETTINGS, $settings );
}


function murm_get_site_settings() {
	$defaults = array(
		'to_user_deny_from_admin' => array(
			'subject' => '[%BLOG_NAME%] Registration request denial',
			'message' => "We are sorry, but your request for registration on blog %BLOG_NAME% with user name %USER_NAME% was denied by this blog's owner. For more information you can contact them via %ADMIN_EMAIL%.\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_admin_new_request' => array(
			'subject' => '[%BLOG_NAME%] New registration request',
			'message' => "There is a new registration request from %USER_NAME% (%USER_EMAIL%) on your blog. For processing it please go to %BLOG_URL%/wp-admin/users.php?page=murm-moderation.\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_superadmin_new_request' => array(
			'subject' => '[%BLOG_NAME%] New registration request',
			'message' => "The admin of %BLOG_NAME% requests registration of user %USER_NAME% (%USER_EMAIL%) on it's blog. For processing it please go to %SITE_URL%/wp-admin/network/users.php?page=murm-superadmin.\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_user_deny_from_superadmin' => array(
			'subject' => '[%BLOG_NAME%] Registration request denial',
			'message' => "We are sorry, but your request for registration on blog %BLOG_NAME% with user name %USER_NAME% was denied by network administrator. For more information you can contact them via %SUPERADMIN_EMAIL%.\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_admin_on_superadmin_deny' => array(
			'subject' => '[%BLOG_NAME%] Registration request from user %USER_NAME% denied',
			'message' => "We are sorry, but your registration request for user %USER_NAME% on your blog %BLOG_NAME% was denied by network administrator. The requesting user has been notified via e-mail. For more information you can the network admin via %SUPERADMIN_EMAIL%.\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_admin_on_superadmin_approve' => array(
			'subject' => '[%BLOG_NAME%] Registration request from user %USER_NAME% approved',
			'message' => "Network administrator has approved your registration request for user %USER_NAME% on your blog %BLOG_NAME%. The requesting user has been notified via e-mail. In case of any problems please contact the network admin via %SUPERADMIN_EMAIL%.\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_new_user_on_approve' => array(
			'subject' => '[%BLOG_NAME%] New user account: %USER_NAME%',
			'message' => "Your registration on the blog %BLOG_NAME% has been approved. Below you can find your login data.\n\nImportant information\n\n(1) This data is assigned to you and to you only. Do no share it with anyone!\n(2) If you request registration on another blog on site %SITE_NAME% in the future, use exactly the same combination of user name and e-mail (%USER_NAME%, %USER_EMAIL%).\n\nIn case of any problems or questions please contact the network administrator via  %SUPERADMIN_EMAIL%.\n\nUser name: %USER_NAME%\nE-mail: %USER_EMAIL%\nPassword: %PASSWORD%\n\nYou can log in here: %LOGIN_URL%.\n\nWelcome!\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		),
		'to_existing_user_on_approve' => array(
			'subject' => '[%BLOG_NAME%] Registration of user account %USER_NAME% approved',
			'message' => "Your registration on the blog %BLOG_NAME% has been approved. For logging in use data sent to you earlier during creation of this user account.\n\nImportant information: If you request registration on another blog on site %SITE_NAME% in the future, use exactly the same combination of user name and e-mail (%USER_NAME%, %USER_EMAIL%).\n\nIn case of any problems or questions please contact the network administrator via  %SUPERADMIN_EMAIL%.\n\nYou can log in here: %LOGIN_URL%.\n\nWelcome!\n\n--\n%SITE_NAME%\nMultisite User Registration Manager"
		)
	);
	
	
	$settings = get_site_option( MURM_SITE_SETTINGS, array(), false );
	return wp_parse_args( $settings, $defaults );
}

?>
